25'ten fazla konu seçemezsiniz Konular bir harf veya rakamla başlamalı, kısa çizgiler ('-') içerebilir ve en fazla 35 karakter uzunluğunda olabilir.
 
 
 
 
 
 

951 satır
22 KiB

  1. #!/bin/bash
  2. # TODO: use tput
  3. # If not running interactively, don't do anything
  4. [[ $- != *i* ]] && return
  5. ##########################################
  6. null(){
  7. "$@" >/dev/null 2>&1
  8. }
  9. __try_exec(){
  10. type $1 >/dev/null 2>&1 && "$@"
  11. }
  12. ##########################
  13. # system type
  14. alias ismsys=false
  15. alias iscygwin=false
  16. alias iswindows=false
  17. alias isdarwin=false
  18. alias islinux=false
  19. alias with_coreutils=false # for mac
  20. case `uname` in
  21. (MINGW*) alias ismsys=true ;;
  22. (CYGWIN*) alias iscygwin=true ;;
  23. (Darwin*) alias isdarwin=true ;;
  24. (Linux*) alias islinux=true ;;
  25. esac
  26. null ls --version && alias with_coreutils=true
  27. ( ismsys || iscygwin ) && alias iswindows=true
  28. alias inbash=false
  29. alias inzsh=false
  30. if test -n "$BASH_VERSION"
  31. then
  32. alias inbash=true
  33. elif test -n "$ZSH_VERSION"
  34. then
  35. alias inzsh=true
  36. fi
  37. #################################
  38. __match(){
  39. # __match str1 str2
  40. # return 0 if str2 is found in str1
  41. expr "$1" : ".*$2.*" >/dev/null
  42. }
  43. if ! __match "$PATH" "$HOME/.local/bin"
  44. then
  45. PATH="${PATH}:${HOME}/.local/bin:$HOME/.local/lib/gems/bin"
  46. fi
  47. if ismsys && ! __match "$PATH" /c/mingw/bin
  48. then
  49. PATH="$PATH:/c/mingw/bin:/c/mingw/msys/1.0/bin"
  50. fi
  51. # # it is not so good
  52. # # http://archive.linux.or.jp/JF/JFdocs/Program-Library-HOWTO/shared-libraries.html
  53. # # http://superuser.com/questions/324613/installing-a-library-locally-in-home-directory-but-program-doesnt-recognize-it
  54. # without this ENV i cannot run tmux. another way is to use --disable-shared
  55. # when building tmux
  56. if ! __match "$LD_LIBRARY_PATH" "$HOME/.local/lib"
  57. then
  58. export LD_LIBRARY_PATH="$LD_LIBRARY_PATH:$HOME/.local/lib"
  59. fi
  60. ##################################
  61. export LANG=ja_JP.UTF-8
  62. export LC_MESSAGES=C
  63. export TERMCAP="${TERMCAP}:vb="
  64. ismsys && export HOSTNAME
  65. export ENV=~/.shrc
  66. if false iswindows
  67. then
  68. export PAGER='tr -d \\r | less'
  69. else
  70. export PAGER="less"
  71. fi
  72. export LESS="-iRMX"
  73. _src_hilite_lp_path="`which src-hilite-lesspipe.sh 2>/dev/null`"
  74. if test -n "$_src_hilite_lp_path"
  75. then
  76. export LESSOPEN="| $_src_hilite_lp_path %s"
  77. fi
  78. if null type vim
  79. then
  80. export EDITOR=vim
  81. else
  82. export EDITOR=vi
  83. fi
  84. # export CDPATH=".:~"
  85. export VISUAL="$EDITOR"
  86. export GIT_PAGER="less -FS"
  87. export GIT_EDITOR="$EDITOR"
  88. export GIT_MERGE_AUTOEDIT=no
  89. if test -n "$TMUX" && \
  90. echo $TERM | grep screen >/dev/null 2>&1 && \
  91. tmux display -p '#{client_termname}' | grep 256color >/dev/null 2>&1
  92. then
  93. TERM=screen-256color
  94. fi
  95. if test -z "$TMP"
  96. then
  97. if test -n "$TMPDIR"
  98. then
  99. export TMP=$TMPDIR
  100. elif test -n "$TEMP"
  101. then
  102. export TMP="$TEMP"
  103. else
  104. export TMP=/tmp
  105. fi
  106. fi
  107. __match "$TMP" "${USER}-tmp" >/dev/null || export TMP="${TMP}/${USER}-tmp"
  108. export TEMP="$TMP"
  109. mkdir -p "$TMP"
  110. ! iswindows && null type stty && {
  111. stty stop undef # unbind C-s to stop displaying output
  112. # stty erase '^h'
  113. }
  114. if iswindows; then
  115. export USER=$USERNAME
  116. fi
  117. _tmux_prefs(){
  118. null type tmux || return 1
  119. tmux set -g mode-keys vi
  120. }
  121. if test -d ~/dbx
  122. then
  123. export CHIT_PATH="$HOME/dbx/.chit"
  124. fi
  125. #######################
  126. iswindows && alias tty="echo cmd.exe"
  127. type fortune >/dev/null 2>&1 && {
  128. fortune
  129. echo
  130. fortune -o
  131. echo
  132. }
  133. uname -a
  134. echo TERM $TERM $(tput colors) colors connected to $(tty), \
  135. running $BASH $BASH_VERSION
  136. if test -n "$TMUX"
  137. then
  138. tmux display -p 'Using tmux #S:#I:#W.#P, client is #{client_termname}' \
  139. 2>/dev/null
  140. echo
  141. fi
  142. ###################################
  143. # some aliases and functions
  144. ( ! with_coreutils && isdarwin ) || test "$TERM" = dumb || \
  145. _coloroption=" --color=auto"
  146. ( ! with_coreutils && isdarwin ) || iswindows || \
  147. _timeoption=" --time-style=long-iso"
  148. ( ! with_coreutils && isdarwin ) || _hideoption=" --hide=[A-Z]*" # do not use
  149. _timeformat_iso="%Y-%m-%dT%H:%M:%S%z"
  150. _timeformat_rfc2822="%a, %d %b %Y %T %z"
  151. _timeformat_num="%Y%m%d%H%M%S"
  152. alias datenum="date +$_timeformat_num"
  153. alias ls="ls -hCF${_coloroption}${_timeoption}"
  154. if ! with_coreutils
  155. then
  156. export LSCOLORS=gxfxcxdxbxegedabagacad
  157. alias ls="ls -G"
  158. fi
  159. # export GREP_OPTIONS=""
  160. alias gr="grep -n --color=always"
  161. iswindows && alias grep="grep -n"
  162. # alias ll="ls -l"
  163. # alias la="ls -A"
  164. # alias lla="ls -Al"
  165. alias less="less -F"
  166. null type emacs && alias em="emacs -nw"
  167. null type vim && alias vi=vim
  168. alias pstree="LANG=C pstree"
  169. alias cp="cp -v"
  170. alias mv="mv -v"
  171. alias rm="rm -v"
  172. alias psaux="ps auxww"
  173. alias q=exit
  174. null type e3em && alias e3=e3em
  175. #alias dirs="dirs -v -l | \grep -v \$(printf '%s$' \$PWD)"
  176. alias po=popd
  177. alias pu=pushd
  178. null type sudo && alias sudo="sudo " # use aliases through sudo
  179. null type sudoedit && alias sudoe="sudoedit"
  180. null type halt && alias halt="sudo halt"
  181. null type reboot && alias reboot="sudo reboot"
  182. null type dbus-send && {
  183. alias suspend="dbus-send --system --print-reply --dest=org.freedesktop.UPower \
  184. /org/freedesktop/UPower org.freedesktop.UPower.Suspend"
  185. alias hibernate="dbus-send --system --print-reply --dest=org.freedesktop.UPower \
  186. /org/freedesktop/UPower org.freedesktop.UPower.Hibernate"
  187. }
  188. alias rand="echo \$RANDOM"
  189. null type file-roller && alias xunp="file-roller -h"
  190. null type paco && alias pc="sudo \paco -D"
  191. alias pycalc="python -i -c 'from math import *' "
  192. null type python3 && alias py3=python3
  193. null type python2 && alias py2=python2
  194. alias _reloadrc="exec \"$SHELL\""
  195. # alias mytime="date +%Y%m%d-%H%M%S"
  196. alias sh="ENV=$HOME/.shrc PS1=\$\ PROMPT_COMMAND="" sh"
  197. # type trash >/dev/null 2>&1 && alias rm=trash
  198. null type mpg123 && alias mpg123="mpg123 -C -v --title"
  199. null type xmms2 && alias xm="xmms2"
  200. #export PLAYER="mpg123 -C -v --title"
  201. null type screen && alias screen="screen -e^z^z"
  202. #alias zcd="cd \`zenity --file-selection --directory\`"
  203. null type gtags && alias gtags="gtags --verbose"
  204. null type htags && alias htags="htags --xhtml --symbol --line-number \
  205. --frame --alphabet --verbose"
  206. null type aunpack && alias au=aunpack
  207. null type lv && alias lv="lv|less"
  208. null type rsync && alias rs="rsync --progress --itemize-changes --compress"
  209. isdarwin && alias updatedb="LC_ALL=C updatedb"
  210. # do not use locate installed by macports
  211. isdarwin && test -x /usr/bin/locate && alias locate="/usr/bin/locate"
  212. # pad
  213. alias pad=notepad
  214. null type gedit && alias pad=gedit
  215. null type leafpad && alias pad=leafpad
  216. isdarwin && alias pad="open -e"
  217. null type wicd-curses && alias wic=wicd-curses
  218. null type wicd-cli && alias wil="wicd-cli -y -l | head"
  219. #alias wicn="wicd-cli -y -c -n"
  220. wicn(){
  221. if test $# -eq 0
  222. then
  223. local num
  224. wicd-cli -y -l | head
  225. echo -n "input num: "
  226. read num
  227. test -n "$num" && wicd-cli -y -c -n $num
  228. else
  229. wicd-cli -y -c -n $1
  230. fi
  231. }
  232. for f in /usr/share/vim/vimcurrent/macros/less.sh \
  233. /usr/share/vim/vim73/macros/less.sh \
  234. /usr/share/vim/vim72/macros/less.sh
  235. do
  236. test -f $f && alias vl=$f && break
  237. done
  238. null type yaourt && alias yt=yaourt
  239. null type cower && alias cower="cower --color=auto"
  240. null type pacmatic && {
  241. alias pacman="pacmatic"
  242. export PACMAN="pacmatic"
  243. }
  244. _pacman_update_mirrorlist_with_reflector(){
  245. ml=/etc/pacman.d/mirrorlist
  246. cmd="$(expr "$(grep -m 1 reflector $ml)" : '# With: *\(.*\)')"
  247. if test -z "$cmd"
  248. then
  249. cmd="reflector --verbose -l 5 --sort rate --save $ml"
  250. fi
  251. echo "Running $cmd ..." 1>&2
  252. sudo $cmd
  253. }
  254. null type reflector && test -f /etc/pacman.d/mirrorlist && \
  255. alias reflect_mirrorlist=_pacman_update_mirrorlist_with_reflector
  256. null type apt-get && {
  257. alias aupgrade="sudo apt-get autoremove --yes && \
  258. sudo apt-get update --yes && sudo apt-get upgrade --yes"
  259. alias aptin="apt-get install"
  260. alias aptsearch="apt-cache search"
  261. alias aptshow="apt-cache show"
  262. }
  263. null type port && {
  264. alias port="port -v"
  265. alias pupgrade="sudo port -v selfupdate && \
  266. { sudo port -v upgrade outdated; }"
  267. }
  268. if iscygwin; then
  269. null type windate || \
  270. alias windate="cmd.exe //c 'echo %DATE%-%TIME%'"
  271. # alias cygsu="cygstart /cygwinsetup.exe"
  272. # alias ls="ls -CFG $(iswindows || test "$TERM" = dumb || echo --color=auto)"
  273. fi
  274. g(){
  275. if test $# -eq 0 && null type git-info
  276. then
  277. git info
  278. else
  279. git "$@"
  280. fi
  281. }
  282. if null type _git && inbash
  283. then
  284. # enable programmable completion for g
  285. complete -o bashdefault -o default -o nospace -F _git g 2>/dev/null \
  286. || complete -o default -o nospace -F _git g
  287. fi
  288. git svn --help >/dev/null 2>&1 && alias gsvn="git svn"
  289. null type gitmemo && alias m=gitmemo
  290. null type gitmemo && alias m=gitmemo
  291. alias setup.py="sudo python3 setup.py install --record files.txt"
  292. ssh(){
  293. __my_set_screen_title ssh
  294. command ssh "$@"
  295. }
  296. clk(){
  297. local tformat="%Y/%m/%d %H:%M:%S %z"
  298. cal
  299. REPLY=
  300. printf "\\r`date "+${tformat}"`"
  301. read -t 1
  302. while test $? -ne 0
  303. do
  304. printf "\\r`date "+${tformat}"`"
  305. read -t 1
  306. done
  307. }
  308. s(){
  309. if git rev-parse --git-dir >/dev/null 2>&1
  310. then
  311. echo ">> git grep -n $@" 1>&2
  312. git grep -n "$@"
  313. elif which ag >/dev/null 2>&1
  314. then
  315. echo ">> ag --pager=\"$PAGER\" $@" 1>&2
  316. ag --pager="$PAGER" "$@"
  317. elif which ack >/dev/null 2>&1
  318. then
  319. echo ">> ack --pager=\"$PAGER\" $@" 1>&2
  320. ack --pager="$PAGER" "$@"
  321. else
  322. echo \
  323. ">> find . " \
  324. "-path '*/.git' -prune -o" \
  325. "-path '*/.svn' -prune -o" \
  326. "-type f -exec grep -nH -e --color=always $@ {} +" 1>&2
  327. if test $# -eq 0
  328. then
  329. echo "No search word given." 1>&2
  330. return 1
  331. fi
  332. find . \
  333. -path '*/.git' -prune -o \
  334. -path '*/.svn' -prune -o \
  335. -type -f -exec grep -nH -e --color=always "$@" {} + \
  336. | $PAGER
  337. fi
  338. }
  339. man(){
  340. env \
  341. LESS_TERMCAP_mb=$(printf "\e[1;35m") \
  342. LESS_TERMCAP_md=$(printf "\e[1;31m") \
  343. LESS_TERMCAP_me=$(printf "\e[0m") \
  344. LESS_TERMCAP_se=$(printf "\e[0m") \
  345. LESS_TERMCAP_so=$(printf "\e[1;44;33m") \
  346. LESS_TERMCAP_ue=$(printf "\e[0m") \
  347. LESS_TERMCAP_us=$(printf "\e[1;32m") \
  348. man "$@"
  349. }
  350. dt(){
  351. # dt <name> [<command ...>]
  352. if test -z "$1"
  353. then
  354. echo "dt: usage: dt <name> [<command ...>]" 1>&2
  355. return 1
  356. fi
  357. soc_name="$1"
  358. shift
  359. if test -S "$soc_name"
  360. then
  361. dtach -a "$soc_name"
  362. elif test -e "$soc_name"
  363. then
  364. echo "dt: File named $soc_name already exists."
  365. return 1
  366. elif test -z "$1"
  367. then
  368. echo "dt: Socket named $soc_name not exists and no command specified."
  369. return 1
  370. else
  371. dtach -c "$soc_name" -e ^^ "$@"
  372. fi
  373. }
  374. scr(){
  375. test -n "$1" && pf="${1}-"
  376. local _tformat="%Y%m%d-%H%M%S%z"
  377. local _file="${HOME}/${pf}`date +${_tformat}`.script"
  378. SCRIPT=${_file} script ${_file} "$@"
  379. }
  380. netwait(){
  381. while ! ping -c 1 -t 1 example.com
  382. do
  383. true
  384. done
  385. echo network works.
  386. }
  387. cd(){
  388. if test $# -eq 0
  389. then
  390. pushd ~/ >/dev/null
  391. elif test "$1" = -
  392. then
  393. local pwd="$PWD"
  394. command cd "$OLDPWD"
  395. pushd -n "$pwd" >/dev/null # stack last dir
  396. elif ! test -d "$1"
  397. then
  398. echo `basename ${SHELL}`: cd: "$1": No such file or directory 1>&2
  399. return 1
  400. else
  401. pushd "$1" >/dev/null
  402. fi
  403. __dirs_rm_dup "$PWD"
  404. echo "$PWD"
  405. }
  406. __dirs_rm_dup(){
  407. for d in "$@"
  408. do
  409. local next="$(__realpath --strip "$d")"
  410. for l in $(\dirs -v -l | cut -d $'\n' -f 2- | \
  411. \grep -x " *[0-9]\+ \+${next}" | \grep -o "^ *[0-9]\+ " | tac)
  412. do
  413. popd +$l -n >/dev/null
  414. done
  415. done
  416. }
  417. __realpath(){
  418. if type realpath >/dev/null 2>&1
  419. then
  420. command realpath "$@"
  421. else
  422. while ! test -d $1
  423. do
  424. shift
  425. done
  426. local d="$OLDPWD"
  427. command cd "$1"
  428. echo "$PWD"
  429. command cd "$d"
  430. fi
  431. }
  432. dh(){
  433. if test $# -eq 0
  434. then
  435. dirs -v -l
  436. else
  437. local dir="$(dirs -v -l | \grep "^ *$1 \+" | sed "s/^ *[0-9]* *//g")"
  438. cd "$dir"
  439. fi
  440. }
  441. input(){
  442. local foo
  443. stty -echo
  444. read foo
  445. stty echo
  446. echo $foo
  447. }
  448. # tmux(){
  449. # if test $# -eq 0
  450. # then
  451. # (cd ~; command tmux start;)
  452. # if command tmux has -t main
  453. # then
  454. # command tmux attach -t main
  455. # else
  456. # (cd ~; command tmux new -s main;)
  457. # fi
  458. # else
  459. # command tmux "$@"
  460. # fi
  461. # }
  462. tx(){
  463. if test $# -eq 0
  464. then
  465. tmux ls
  466. echo "tx <session> to attach."
  467. elif tmux has -t "$1"
  468. then
  469. tmux attach -t "$1"
  470. else
  471. tmux new -s "$1"
  472. fi
  473. }
  474. mcrypt-stream(){
  475. test $# -eq 2 || return 1
  476. case $1 in
  477. en)
  478. mcrypt --key $2 | base64 ;;
  479. de)
  480. base64 -d | mcrypt -d --key $2 ;;
  481. esac
  482. }
  483. gpg-stream(){
  484. test $# -eq 2 || return 1
  485. case $1 in
  486. en)
  487. gpg --passphrase $2 -c --batch |base64 ;;
  488. de)
  489. base64 -d|gpg --passphrase $2 -d --batch ;;
  490. esac
  491. }
  492. dgpg(){
  493. if test "$1" = help || test -z "$2"
  494. then
  495. echo "dgpg: dgpg <en|de> <src-suffix> [<dst-suffix>]" 1>&2
  496. return
  497. fi
  498. local srcs="$2"
  499. local dsts="$3"
  500. test -z "$dsts" && dsts="${srcs}.out"
  501. local pw
  502. echo -n "dgpg pw: "
  503. read -s pw
  504. echo ""
  505. test -z "$pw" && return 1
  506. for f in *${srcs}
  507. do
  508. local d="$(basename "$f" "${srcs}")${dsts}"
  509. echo -n "Processing $f to $d..."
  510. if test -d "$f"
  511. then
  512. echo "`printf 'failed (%s is directory)' $f`"
  513. elif test -f "$d"
  514. then
  515. echo "`printf 'failed (%s is already exists)' $d`"
  516. elif <"$f" gpg-stream $1 $pw >"$d" 2>/dev/null
  517. then
  518. echo "done"
  519. else
  520. echo "failed"
  521. test -f "$d" && rm "$d"
  522. fi
  523. done
  524. }
  525. alias enst="gpg-stream en"
  526. alias dest="gpg-stream de"
  527. showinfo(){
  528. echo "Japanese letters are 表示可能"
  529. __try_exec diskinfo
  530. ! isdarwin && test -n "${DISPLAY}" && {
  531. __try_exec xrandr | \grep --color=never ^Screen
  532. }
  533. iswindows || __try_exec finger $USER
  534. LANG=C __try_exec id
  535. __try_exec xset q
  536. }
  537. x(){
  538. if [[ -z $DISPLAY ]] && ! [[ -e /tmp/.X11-unix/X0 ]] && (( EUID )); then
  539. #mkdir -p ~/.my/log
  540. # nohup startx >~/.my/log/xorg.log 2>&1 &
  541. # exit
  542. exec startx
  543. else
  544. echo "X cant be started! Another X is already running?" 1>&2
  545. fi
  546. }
  547. bak(){
  548. for file in "$@"
  549. do
  550. cp -v ${file} ${file}.bak
  551. done
  552. }
  553. di(){
  554. if type colordiff >/dev/null 2>&1 && test $TERM != dumb
  555. then
  556. local diffcmd=colordiff
  557. else
  558. local diffcmd=diff
  559. fi
  560. ${diffcmd} -u "$@" | ${PAGER}
  561. }
  562. tb(){
  563. local tb="$HOME/.my/tb"
  564. mkdir -p "$tb"
  565. for file in "$@"
  566. do
  567. mv -t "$tb" "$file"
  568. done
  569. }
  570. mkcd(){
  571. if test -z "$1"
  572. then
  573. echo "mkcd: usage: mkcd <dir>"
  574. return 1
  575. elif test -d "$1"
  576. then
  577. echo "Dir \"$1\" already exists."
  578. else
  579. mkdir -p "$1"
  580. echo "Dir \"$1\" created."
  581. fi
  582. cd "$1"
  583. }
  584. mkcdd(){
  585. # make and change date directory
  586. _d=`date +%Y%m%d-%H%M%S`
  587. mkcd "$_d"
  588. }
  589. if test -n "$TMUX" && null type reattach-to-user-namespace
  590. then
  591. alias pbpaste="reattach-to-user-namespace pbpaste"
  592. alias pbcopy="reattach-to-user-namespace pbcopy"
  593. fi
  594. catclip(){
  595. if iswindows
  596. then
  597. cat /dev/clipboard | tr -d \\r
  598. elif isdarwin
  599. then
  600. pbpaste
  601. else
  602. xclip -o -selection "clipboard"
  603. fi
  604. }
  605. setclip(){
  606. if test $# -eq 0
  607. then
  608. exec 3<&0
  609. else
  610. exec 3<<__EOF__
  611. `cat "$@"`
  612. __EOF__
  613. fi
  614. if iswindows
  615. then
  616. 0<&3 sed -e 's/$/\r/' | tee /dev/clipboard
  617. elif isdarwin
  618. then
  619. pbcopy 0<&3
  620. else
  621. 0<&3 xclip -i -f -selection "primary" | \
  622. xclip -i -f -selection "clipboard"
  623. fi
  624. exec 3<&-
  625. }
  626. open_file(){
  627. if iswindows
  628. then
  629. cmd.exe //c start "" "$@"
  630. elif isdarwin
  631. then
  632. touch "$@"
  633. open "$@"
  634. elif islinux
  635. then
  636. touch "$@"
  637. if null type pcmanfm; then
  638. LC_MESSAGES= pcmanfm "$@"
  639. else
  640. LC_MESSAGES= xdg-open "$@" &
  641. fi
  642. else
  643. cat "$@"
  644. fi
  645. }
  646. o(){
  647. if test $# -eq 0
  648. then
  649. open_file .
  650. else
  651. for f in "$@"
  652. do
  653. open_file "$(realpath "$f")"
  654. done
  655. fi
  656. }
  657. convmv-sjis2utf8-test(){
  658. convmv -r -f sjis -t utf8 *
  659. }
  660. convmv-sjis2utf8-notest(){
  661. convmv -r -f sjis -t utf8 * --notest
  662. }
  663. winln(){
  664. # for windose make link (actually junction)
  665. if test $# -eq 0
  666. then
  667. {
  668. echo "usage: winln TARGET LINK_NAME"
  669. echo "Create a link to TARGET with the name LINK_NAME \
  670. (that is, TARGET must already exist)."
  671. echo "About other features run 'junction'."
  672. } 1>&2
  673. return 1
  674. else
  675. junction "$2" "$1"
  676. fi
  677. }
  678. #################################################
  679. ## pastebin services
  680. ## https://wiki.archlinux.org/index.php/List_of_Applications/Internet#Pastebin_clients
  681. sprunge(){
  682. # http://sprunge.us
  683. if test -z "$1"
  684. then
  685. curl -F 'sprunge=<-' http://sprunge.us
  686. else
  687. curl http://sprunge.us/$1
  688. fi
  689. }
  690. dpaste(){
  691. # http://dpaste.de
  692. if test -z "$1"
  693. then
  694. curl -F 'content=<-' https://dpaste.de/api/
  695. echo
  696. else
  697. curl https://dpaste.de/$1/raw/
  698. fi
  699. }
  700. ######################################
  701. ## Prompt
  702. __my_moc_state(){
  703. type mocp >/dev/null 2>&1 || return
  704. test "`mocp -Q %state 2>/dev/null`" = PLAY || return
  705. printf "$1" "`mocp -Q %title 2>/dev/null`"
  706. }
  707. __my_parse_svn_branch() {
  708. local LANG=C
  709. local svn_url=$(svn info 2>/dev/null | sed -ne 's#^URL: ##p')
  710. local svn_repository_root=$(svn info 2>/dev/null | \
  711. sed -ne 's#^Repository Root: ##p')
  712. echo ${svn_url} | sed -e 's#^'"${svn_repository_root}"'##g' | \
  713. awk '{print $1}'
  714. }
  715. __my_svn_ps1(){
  716. if svn status >/dev/null 2>&1
  717. then
  718. local svn_branch=$(__my_parse_svn_branch)
  719. test -n "${svn_branch}" && printf "$1" "{$svn_branch}"
  720. fi
  721. }
  722. __my_battery_status(){
  723. local dir=/sys/class/power_supply/BAT0
  724. if test -d $dir && test -r $dir/status && test -r $dir/charge_full && \
  725. test -r $dir/charge_now
  726. then
  727. local st=$(cat $dir/status)
  728. local full=$(cat $dir/charge_full)
  729. local now=$(cat $dir/charge_now)
  730. local rate=$(expr $now \* 100 / $full)
  731. printf "$1" "${st}:${rate}%"
  732. fi
  733. }
  734. alias bat='__my_battery_status %s\\n'
  735. ip-address(){
  736. type ip >/dev/null 2>&1 || return 1
  737. local ip=$(LANG=C ip addr show scope global | \
  738. \grep --color=never --only-matching 'inet [^ ]*' | cut -d " " -f 2)
  739. test -n "$ip" && printf $1 $ip
  740. }
  741. test -n "$SCRIPT" && __my_ps1_script_str="${__my_c5}SCR${__my_cdef} "
  742. test -n "$SSH_CONNECTION" && __my_ps1_ssh_str="${__my_c5}SSH${__my_cdef} "
  743. __my_ps1_scale(){
  744. local last=$?
  745. if null type stty && ! ismsys
  746. then
  747. stty size | tr -d $'\n' | tr " " x
  748. printf " "
  749. fi
  750. return $last
  751. }
  752. __my_ps1_tmux(){
  753. local last=$?
  754. null type tmux || return $last
  755. local tmuxc="$(tmux display -p '#S:#I:#W.#P' 2>/dev/null)"
  756. test -n "$TMUX" && echo "[TMUX:$tmuxc]"
  757. return $last
  758. }
  759. __my_ps1_moc(){
  760. local last=$?
  761. __my_moc_state "[MOC:%s]"
  762. return $last
  763. }
  764. for f in /usr/share/git/git-prompt.sh \
  765. /opt/local/share/git-core/git-prompt.sh \
  766. /opt/local/share/doc/git-core/contrib/completion/git-prompt.sh
  767. do
  768. test -r "$f" && . "$f" && break
  769. done
  770. GIT_PS1_SHOWDIRTYSTATE=t
  771. GIT_PS1_SHOWUPSTREAM=t
  772. __my_ps1_git(){
  773. local last=$?
  774. null type __git_ps1 || return $last
  775. null git rev-parse --git-dir >/dev/null 2>&1 || return $last
  776. __git_ps1 "[GIT:$(__try_exec git config --get user.name):%s]"
  777. return $last
  778. }
  779. __my_ps1_ipaddr(){
  780. local last=$?
  781. ! iswindows && ip-address [Addr:%s]
  782. return $last
  783. }
  784. __my_ps1_bttry(){
  785. local last=$?
  786. local bst="${TMP}/batterystatus"
  787. if test -z "$DISPLAY" && ! iswindows
  788. then
  789. test -f $bst && local bstr="$(cat $bst)"
  790. test -n "$bstr" && ! echo $bstr | grep 100 >/dev/null 2>&1 && \
  791. echo "[Battery:$bstr]"
  792. __my_battery_status %s >$bst &
  793. fi
  794. return $last
  795. }
  796. __my_ps1_dirs(){
  797. dirs | wc -l
  798. }
  799. __my_ps1_jobs(){
  800. jobs | wc -l
  801. }
  802. if test "$TERM" != dumb
  803. then
  804. __my_c1="\[\e[0;33m\]" # color for PWD
  805. __my_c2="\[\e[0;36m\]" # color for user
  806. __my_c3="\[\e[1;30m\]" # color for OLDPWD
  807. if test "`hostname`" = arch-aspireone; then __my_c4="\[\e[1;34m\]"
  808. elif test "`hostname`" = darwin-mba.local; then __my_c4="\[\e[1;31m\]"
  809. elif test "`hostname`" = newkiwi; then __my_c4="\[\e[1;35m\]"
  810. else __my_c4="\[\e[1;32m\]" # color for ::
  811. fi
  812. __my_c5="\[\e[30;47m\]" # color for SCR
  813. __my_cdef="\[\e[0m\]"
  814. fi
  815. # export _LAST_STATUS=a
  816. # __my_export_last_status(){
  817. # local last=$?
  818. # echo $last
  819. # export _LAST_STATUS=$last
  820. # echo $_LAST_STATUS
  821. # return $last
  822. # }
  823. _ps1_bash="\
  824. ${__my_c4}:: ${__my_cdef}[${__my_c2}\u@\H${__my_cdef}:${__my_c1}\w/${__my_cdef}]\$(__my_ps1_git)\$(__my_ps1_bttry)\$(__my_ps1_ipaddr)\$(__my_ps1_moc)\n\
  825. ${__my_c4}:: ${__my_cdef}l${SHLVL}n\#j\js\$? $(__my_ps1_scale) \D{%T} ${__my_ps1_script_str}${__my_ps1_ssh_str}\$ "
  826. inbash && PS1=$_ps1_bash
  827. __my_set_screen_title(){
  828. if test -n "$TMUX" && test -z "$INSIDE_EMACS"
  829. then
  830. echo -ne "\033k$1\033\\"
  831. fi
  832. }
  833. __my_set_title(){
  834. case $TERM in
  835. (rxvt*|xterm*|aterm|screen*)
  836. title="$(echo $@)"
  837. test -t 1 &&
  838. test -n "$DISPLAY" &&
  839. test -z "$EMACS" &&
  840. echo -n -e "\033]0;${title}\007"
  841. ;;
  842. esac
  843. }
  844. PROMPT_COMMAND="__my_set_title \${USER}@\${HOSTNAME}\:\${PWD};
  845. __my_set_screen_title \$(basename \"\$PWD\")/"